<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="{{ url_for('static' , filename = '/js/jquery/jquery-3.6.0.min.js')}}"></script>
    <script src="{{ url_for('static' , filename = '/js/jquery/jquery.cookie.js')}}"></script>
    <title>jQuery - Cookies</title>
  </head>
  <body>
    <h1>jQuery - Cookies</h1>
    <a href="https://plugins.jquery.com/cookie/">jQuery Cookie - Plugin</a
    ><br />
    <a href="https://github.com/carhartl/jquery-cookie"
      >jQuery Cookie - GitHub</a
    >

    <h3>Example :</h3>
    <ul>
      <li>1. account : DevAuth</li>
      <li>2. isRememberMe : true</li>
      <li>3. shoppingCart : 1,2,3,4,5</li>
      <li>4. buyNextTime : 6,7,8,9,10</li>
      <li>5. queryRecord : Cookie,Session</li>
    </ul>

    <p>key : <input type="text" id="edtKey" /></p>
    <p>value : <input type="text" id="edtValue" /></p>
    <button id="btnSave">Save</button>
    <button id="btnRead">Read</button>
    <button id="btnDelete">Delete</button>
    <hr />
    <h3>Result :</h3>
    <div id="console"></div>
    <hr />
    <h3>Cookies :</h3>
    <div id="data"></div>
    <hr />
    <h3>Login :</h3>
    帳號 : <input id="edtAc" type="text" />
    <input id="chkRememberMe" type="checkbox" />記住我<br />
    密碼 : <input id="edtPw" type="password" />
    <button id="btnLogin">Login</button>

    <script>
      $(function () {
        var $edtKey = $("#edtKey");
        var $edtValue = $("#edtValue");

        var $btnSave = $("#btnSave");
        var $btnRead = $("#btnRead");
        var $btnDelete = $("#btnDelete");

        var $console = $("#console");
        var $data = $("#data");

        var $edtAccount = $("#edtAc");
        var $edtPassword = $("#edtPw");
        var $chkRememberMe = $("#chkRememberMe");
        var $btnLogin = $("#btnLogin");

        var lstData = [];

        $btnSave.off("click").on("click", function () {
          var key = $edtKey.val();
          var val = $edtValue.val();

          // $.cookie(key , val);
          $.cookie(key, val, { expires: 1, path: "/" });

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");
          showCookie();
          showLoginInfo();
        });

        $btnRead.off("click").on("click", function () {
          var key = $edtKey.val();
          var val = $.cookie(key);

          $edtKey.val("");
          $edtValue.val("");
          $console.text("key = " + key + " , value = " + val);

          showCookie();
          showLoginInfo();
        });

        $btnDelete.off("click").on("click", function () {
          let key = $edtKey.val();
          // let val = $.removeCookie(key);
          let val = $.removeCookie(key, { path: "/" });
          if (!val) {
            alert("Delete Fail !");
          }

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");

          showCookie();
          showLoginInfo();
        });

        $btnLogin.off("click").on("click", function () {
          let account = $edtAccount.val();
          let isRememberMe = $chkRememberMe.prop("checked");

          if (isRememberMe) {
            $.cookie("account", account, { expires: 1, path: "/" });
            $.cookie("isRememberMe", isRememberMe, { expires: 1, path: "/" });
            showCookie();
            showLoginInfo();
          } else {
            // $.removeCookie("account");
            // $.removeCookie("isRememberMe");
            $.removeCookie("account", { path: "/" });
            $.removeCookie("isRememberMe", { path: "/" });

            showCookie();
            showLoginInfo();
          }

          alert("OK");
        });

        function showCookie() {
          $data.html("");
          lstData = [];
          var cookie = $.cookie();
          var i = 0;
          $.each(cookie, function (key, val) {
            var btnSelect =
              "<button name='btnSelect' value=" + i + ">Select</butotn>";
            lstData.push({ key: key, val: val });
            $data.append(btnSelect);
            $data.append(" ");
            $data.append(key);
            $data.append("=");
            $data.append(val);
            $data.append("<br>");
            i++;
          });

          for (var i = 0; i < cookie.length; i++) {
            var data = cookie[i];
            if (data.indexOf("=") != -1) {
              var arr = data.split("=");
            }
          }

          var $btnSelect = $("[name=btnSelect]");
          $btnSelect.off("click").on("click", function () {
            let idx = $(this).val();
            $edtKey.val(lstData[idx].key);
          });
        }

        function showLoginInfo() {
          let account = $.cookie("account");
          let isRememberMe = $.cookie("isRememberMe") == "true";

          if (isRememberMe) {
            $edtAccount.val(account);
          } else {
            $edtAccount.val("");
          }

          $chkRememberMe.prop("checked", isRememberMe);
          $edtPassword.val("");

        }

        showLoginInfo();
        showCookie();
      });
    </script>
  </body>
</html>
